# Record Class LLPassword

java.lang.Object
java.lang.Record
com.io7m.looseleaf.security.LLPassword

Record Components:
  `algorithm` - The hash algorithm
  `hash` - The hashed password
  `salt` - The salt value

public record LLPassword(LLPasswordAlgorithmType algorithm, String hash, String salt) extends Record
A hashed password for a user.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final Pattern`
  `VALID_HEX`
  The pattern that defines a valid hash.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LLPassword(LLPasswordAlgorithmType algorithm, String hash, String salt)`
  A hashed password for a user.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `LLPasswordAlgorithmType`
  `algorithm()`
  Returns the value of the `algorithm` record component.
  `boolean`
  `check(String passwordText)`
  Check the given plain text password against this hashed password.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `String`
  `hash()`
  Returns the value of the `hash` record component.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `String`
  `salt()`
  Returns the value of the `salt` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### VALID_HEX

    public static final Pattern VALID_HEX
    The pattern that defines a valid hash.

- ## Constructor Details

  - ### LLPassword

    public LLPassword(LLPasswordAlgorithmType algorithm, String hash, String salt)
    A hashed password for a user.
    Parameters:
      `algorithm` - The hash algorithm
      `hash` - The hashed password
      `salt` - The salt value

- ## Method Details

  - ### check

    public boolean check(String passwordText) throws LLPasswordException
    Check the given plain text password against this hashed password.
    Parameters:
      `passwordText` - The plain text password
    Returns:
      `true` iff the password matches
    Throws:
      `LLPasswordException` - On com.io7m.looseleaf.cmdline.internal errors such as missing algorithm support
    See Also:
      - `LLPasswordAlgorithmType.check(String, String, byte[])`

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### algorithm

    public LLPasswordAlgorithmType algorithm()
    Returns the value of the `algorithm` record component.
    Returns:
      the value of the `algorithm` record component

  - ### hash

    public String hash()
    Returns the value of the `hash` record component.
    Returns:
      the value of the `hash` record component

  - ### salt

    public String salt()
    Returns the value of the `salt` record component.
    Returns:
      the value of the `salt` record component